grenade = {}

function grenade.load()
	grenade.numOf = 0
	
	grenade.img = love.graphics.newImage('textures/grenade/grenade.png')
	grenade.imgW = grenade.img:getWidth()
	grenade.imgH = grenade.img:getHeight()
	
	grenade.explosionSS = love.graphics.newImage('textures/grenade/explosion.png')
	
	grenade.explosionMark = love.graphics.newImage('textures/grenade/explosionmark.png')
	
	grenade.explosionSound = {}
	grenade.explosionSound[1] = 'sound/explosion1.ogg'
	grenade.explosionSound[2] = 'sound/explosion2.ogg'
	
	grenade.collisionSound = {}
	grenade.collisionSound[1] = love.audio.newSource('sound/grenade1.ogg', 'static')
	grenade.collisionSound[1]:setPitch(1.3)
	
	grenade.bounce = 0.6
	
	function grenade.throw(dir, n)
		if monkey[n].grenadeCD < 0 and monkey[n].alive then
			grenade.numOf = grenade.numOf + 1
			grenade[grenade.numOf] = {}
			grenade[grenade.numOf].x = monkey[n].x
			grenade[grenade.numOf].y = monkey[n].y - monkey.height/2
			grenade[grenade.numOf].rot = love.math.random(-math.pi/2, math.pi/2)
			grenade[grenade.numOf].xVel = monkey[n].xVel + 450*dir*ui.K
			grenade[grenade.numOf].yVel = monkey[n].yVel + 200*ui.K
			grenade[grenade.numOf].timer = 3
			grenade[grenade.numOf].rotVel = love.math.random(-1, 1)
			grenade[grenade.numOf].inWall = {}
			for f = 1, world.numOfWalls, 1 do
				grenade[grenade.numOf].inWall[f] = false
			end
			grenade[grenade.numOf].blewUp = false
			grenade[grenade.numOf].explosion = newAnimation(grenade.explosionSS, 200, 200, 0.1, 0)
			grenade[grenade.numOf].explosion:setMode('once')
			grenade[grenade.numOf].drawExplosion = false
			grenade[grenade.numOf].explosionSoundTimer = 2
			grenade[grenade.numOf].explosionSound = love.audio.newSource(grenade.explosionSound[love.math.random(1, 2)])
			monkey[n].grenadeCD = 0.5
		end
	end
end

function grenade.update(dt)
	for g = 1, grenade.numOf, 1 do
		if gamestate == 'playing' or gamestate == 'ended' then
			if not grenade[g].blewUp then
				grenade[g].timer = grenade[g].timer - dt
				
				grenade[g].x = grenade[g].x + grenade[g].xVel * dt
				grenade[g].y = grenade[g].y - grenade[g].yVel * dt
				grenade[g].rot = grenade[g].rot - grenade[g].rotVel * dt
				
				--Работа с силами
				grenade[g].xVel = grenade[g].xVel * (1 - math.min(dt*0.4*ui.K, 1))
				grenade[g].yVel = grenade[g].yVel - 400*ui.K * dt
				
				if grenade[g].xVel > 600*ui.K then
					grenade[g].xVel = 600*ui.K
				elseif grenade[g].xVel < -600*ui.K then
					grenade[g].xVel = -600*ui.K
				end
				
				if grenade[g].yVel > 600*ui.K then
					grenade[g].yVel = 600*ui.K
				elseif grenade[g].yVel < -600*ui.K then
					grenade[g].yVel = -600*ui.K
				end
				
				for f = 1, world.numOfWalls, 1 do
					if grenade[g].x >= world.wall[f].x and grenade[g].x <= world.wall[f].x + world.wall[f].w and
					grenade[g].y > world.wall[f].y - grenade.imgW then
						grenade[g].rotVel = -grenade[g].xVel/grenade.imgH
					end
				end
				
				if grenade[g].timer < 0 then
					grenade[g].blewUp = true
					for n = 1, monkey.numOf, 1 do
						if ((grenade[g].x - monkey[n].x)^2 + (grenade[g].y - monkey[n].y)^2)^0.5 < 200*ui.K then
							if world.currentLevel ~= 0 then
								monkey[n].hp = monkey[n].hp - 100 * (100*ui.K/(((grenade[g].x - monkey[n].x)^2 + (grenade[g].y - (monkey[n].y - monkey.height/2))^2)^0.5))
							end
							monkey[n].xVel = monkey[n].xVel + 10000*ui.K/(monkey[n].x - grenade[g].x)
							monkey[n].yVel = monkey[n].yVel - 10000*ui.K/(monkey[n].y - monkey.height/2 - grenade[g].y)
						end
					end
					for h = 1, grenade.numOf, 1 do
						if h ~= g then
							if ((grenade[g].x - grenade[h].x)^2 + (grenade[g].y - grenade[h].y)^2)^0.5 < 200*ui.K then
								grenade[h].xVel = grenade[h].xVel + 10000*ui.K/(grenade[h].x - grenade[g].x)
								grenade[h].yVel = grenade[h].yVel + 10000*ui.K/(grenade[g].y - grenade[h].y)
							end
						end
					end
				end
			else
				grenade[g].drawExplosion = true
				grenade[g].explosion:update(dt)
				grenade[g].explosionSoundTimer = grenade[g].explosionSoundTimer - dt
				if grenade[g].explosionSoundTimer > 0 then
					if not ui.muteSound then
						grenade[g].explosionSound:play()
					end
				else
					grenade[g].explosionSound:stop()
				end
				if grenade[g].explosion:getCurrentFrame() >= 5 then
					grenade[g].drawExplosion = false
				end
			end
		end
	end
end

function grenade.draw()
	for g = 1, grenade.numOf, 1 do
		if not grenade[g].blewUp then
			love.graphics.draw(grenade.img, grenade[g].x, grenade[g].y, grenade[g].rot, ui.K, ui.K, grenade.imgW/2, grenade.imgH/2)
		elseif grenade[g].drawExplosion then
			grenade[g].explosion:draw(grenade[g].x, grenade[g].y, grenade[g].rot, ui.K, ui.K, 100, 100)
		end
	end
end