level = {}

function level.createWall(x, y, w, h)
	world.numOfWalls = world.numOfWalls + 1
	
	world.wall[world.numOfWalls] = {}
	world.wall[world.numOfWalls].x = x*ui.K
	world.wall[world.numOfWalls].y = y*ui.K
	world.wall[world.numOfWalls].w = w*ui.K
	world.wall[world.numOfWalls].h = h*ui.K
end

function level.texturise()
	for f = 1, world.numOfWalls, 1 do
		world.wall[f].tile = {}
		for tr = 1, world.wall[f].w/12, 1 do
			for t = 1, world.wall[f].h/12, 1 do
				world.wall[f].tile[tr*t] = math.random(3)
			end
		end
	end
end

function level.load0()
	world.currentLevel = 0
	
	monkey[1].x = love.graphics.getWidth()*0.25
	monkey[2].x = love.graphics.getWidth()*0.75
	monkey[1].y = world.grLvl - 5
	monkey[2].y = world.grLvl - 5
	
	world.numOfWalls = 0
	
	level.createWall(-2, 720 - 20, 1284, 48)
	
	level.texturise()
end

function level.load1()
	world.currentLevel = 1
	
	monkey[1].x = love.graphics.getWidth()*0.25
	monkey[2].x = love.graphics.getWidth()*0.75
	monkey[1].y = world.grLvl - 5
	monkey[2].y = world.grLvl - 5
	
	world.numOfWalls = 0
	
	level.createWall(-2, 700, 1284, 48)
	level.createWall(-12, 720*0.80, 216, 24)
	level.createWall(1280 - 204, 720*0.80, 216, 24)
	level.createWall(184, 720*0.60, 912, 24)
	level.createWall(-12, 720*0.40, 132, 24)
	level.createWall(1280 - 120, 720*0.40, 132, 24)
	level.createWall(298, 720*0.30, 204, 24)
	level.createWall(778, 720*0.30, 204, 24)
	
	level.texturise()
end

function level.load2()
	world.currentLevel = 2
	
	monkey[1].x = love.graphics.getWidth()/2 - 96*5 - 24
	monkey[2].x = love.graphics.getWidth()/2 + 96*5 + 24
	monkey[1].y = love.graphics.getHeight()/2 + 120 - 5
	monkey[2].y = love.graphics.getHeight()/2 + 120 - 5
	
	world.numOfWalls = 0
	
	level.createWall(1280/2 - 24, 720/2, 48, 720/2)
	level.createWall(1280/2 - 96 - 48, 720/2 + 24, 48, 720/2)
	level.createWall(1280/2 + 96, 720/2 + 24, 48, 720/2)
	level.createWall(1280/2 - 96*2 - 48, 720/2 + 48, 48, 720/2)
	level.createWall(1280/2 + 96*2, 720/2 + 48, 48, 720/2)
	level.createWall(1280/2 - 96*3 - 48, 720/2 + 72, 48, 720/2)
	level.createWall(1280/2 + 96*3, 720/2 + 72, 48, 720/2)
	level.createWall(1280/2 - 96*4 - 48, 720/2 + 96, 48, 720/2)
	level.createWall(1280/2 + 96*4, 720/2 + 96, 48, 720/2)
	level.createWall(1280/2 - 96*5 - 48, 720/2 + 120, 48, 720/2)
	level.createWall(1280/2 + 96*5, 720/2 + 120, 48, 720/2)
	level.createWall(1280/2 - 96*6 - 48, 720/2 + 144, 48, 720/2)
	level.createWall(1280/2 + 96*6, 720/2 + 144, 48, 720/2)
	
	level.texturise()
end

function level.load3()
	world.currentLevel = 3
	
	monkey[1].x = love.graphics.getWidth()*0.25
	monkey[2].x = love.graphics.getWidth()*0.75
	monkey[1].y = world.grLvl - 5
	monkey[2].y = world.grLvl - 5
	
	world.numOfWalls = 0
	
	level.createWall(-2, 720 - 20, 1284, 48)
	level.createWall(1280/2 - 24, 720*0.6, 48, 720/2)
	level.createWall(1280/2 - 24 - 108, 720*0.75, 120, 24)
	level.createWall(1280/2 + 12, 720*0.75, 120, 24)
	level.createWall(-12, 330, 348, 24)
	level.createWall(948, 330, 348, 24)
	level.createWall(336, 330, 48, 72)
	level.createWall(900, 330, 48, 72)
	level.createWall(538, 160, 204, 48)
	
	level.texturise()
end

function level.load4()
	world.currentLevel = 4
	
	monkey[1].x = love.graphics.getWidth()*0.25
	monkey[2].x = love.graphics.getWidth()*0.75
	monkey[1].y = world.grLvl - 5
	monkey[2].y = world.grLvl - 5
	
	world.numOfWalls = 0
	
	level.createWall(-2, love.graphics.getHeight() - 20, 1284, 48)
	level.createWall(love.graphics.getWidth()/2 - 6, -12, 12, love.graphics.getHeight()*0.4 + 24)
	level.createWall(love.graphics.getWidth()/2 - 156, love.graphics.getHeight()*0.4 + 12, 312, 24)
	level.createWall(340, love.graphics.getHeight()*0.65, 600, 24)
	level.createWall(-12, love.graphics.getHeight()*0.8, 360, 24)
	level.createWall(love.graphics.getWidth()-352, love.graphics.getHeight()*0.8, 360, 24)
	level.createWall(200, 150, 72, 72)
	level.createWall(love.graphics.getWidth() - 200 - 72, 150, 72, 72)
	level.createWall(-12, 198, 224, 24)
	level.createWall(love.graphics.getWidth() - 212, 198, 224, 24)
	
	
	level.texturise()
end

function level.load5()
	world.currentLevel = 5
	
	monkey[1].x = love.graphics.getWidth()*0.25
	monkey[2].x = love.graphics.getWidth()*0.75
	monkey[1].y = love.graphics.getHeight()*0.4 - 5
	monkey[2].y = love.graphics.getHeight()*0.4 - 5
	
	world.numOfWalls = 0
	
	level.createWall(-2, love.graphics.getHeight() - 20, 1284, 48)
	level.createWall(430, love.graphics.getHeight()*0.6, 420, 24)
	level.createWall(100, love.graphics.getHeight()*0.4, 300, 24)
	level.createWall(love.graphics.getWidth() - 400, love.graphics.getHeight()*0.4, 300, 24)
	level.createWall(100, love.graphics.getHeight()*0.8, 300, 24)
	level.createWall(love.graphics.getWidth() - 400, love.graphics.getHeight()*0.8, 300, 24)
	
	level.texturise()
end