require('monkey')
require('world')
require('grenade')
require('ui')
require('level')
require('music')

require('AnAL')

version = '1.4.0.m'

function love.load()
	opSys = love.system.getOS()
	
	gamestate = 'startScreen'
	
	ui.load()
	monkey.load()
	world.load()
	grenade.load()
	music.load()
	
	love.audio.setVolume(0.2)
end

function love.update(dt)
	if dt < 0.4 then
		ui.update(dt)
		monkey.update(dt)
		world.update(dt)
		grenade.update(dt)
		music.update(dt)
		function love.keypressed(key)
			monkey.keys(key)
			ui.info(key)
			ui.levelSelectKey(key)
		end
		function love.mousepressed(x, y, mb)
			ui.levelSelect(x, y, mb)
			ui.mute(x, y, mb)
			ui.pauseExit(x, y, mb)
		end
		function love.touchreleased(id, x, y, dx, dy, pressure)
			ui.levelSelectMob(id, x, y, dx, dy)
			ui.restartMob(id, x, y, dx, dy)
			monkey.releaseMove(id, x, y, dx, dy)
			ui.startScreenSkipMob(id, x, y, dx, dy)
		end
		function love.touchpressed(id, x, y, dx, dy, pressure)
			ui.infoMob(id, x, y, dx, dy)
		end
	end
end

function love.draw()
	world.draw()
	monkey.draw()
	grenade.draw()
	ui.draw()
	music.draw()
end