monkey = {}

function monkey.load()
	monkey.idle = love.graphics.newImage('textures/monkey/monkey_idle.png')
	monkey.width = monkey.idle:getWidth()*ui.K
	monkey.height = monkey.idle:getHeight()*ui.K
	monkey.walkingSS = love.graphics.newImage('textures/monkey/monkey_walking.png')
	
	monkey.endTimer = 1
	
	monkey.numOf = 2
	
	monkey.speed = 50*ui.K
	
	monkey.hat = {}
	monkey.hat.count = 4
	
	for n = 1, monkey.hat.count do
		monkey.hat[n] = {}
		monkey.hat[n].img = love.graphics.newImage('textures/monkey/hat/'..n..'.png')
		monkey.hat[n].w = monkey.hat[n].img:getWidth()
		monkey.hat[n].h = monkey.hat[n].img:getHeight()
	end
	
	monkey.hat[2].yO = 4*ui.K
	monkey.hat[3].yO = 4*ui.K
	monkey.hat[4].yO = -16*ui.K
	
	for n = 1, monkey.hat.count do
		if monkey.hat[n].xO == nil then
			monkey.hat[n].xO = 0
		end
		if monkey.hat[n].yO == nil then
			monkey.hat[n].yO = 0
		end
	end
	
	for n = 1, monkey.numOf, 1 do
		monkey[n] = {}
		
		monkey[n].walking = newAnimation(monkey.walkingSS, monkey.width/ui.K, monkey.height/ui.K, 0.2, 0)
		
		monkey[n].moving = false
		
		monkey[n].xVel = 0
		monkey[n].yVel = 0
		monkey[n].direction = 1
		monkey[n].moveK = 0
		monkey[n].hp = 100
		monkey[n].alive = true
		monkey[n].grenadeCD = 0
		monkey[n].jX = 0
		monkey[n].jY = 0
		monkey[n].walkingSound = {}
		monkey[n].walkingSound[1] = love.audio.newSource('sound/walk1.ogg', 'static')
		monkey[n].walkingSound[1]:setVolume(0.3)
		monkey[n].walkSoundTimer = 0
		monkey[n].jumpingSound = {}
		monkey[n].jumpingSound[1] = love.audio.newSource('sound/jump1.ogg', 'static')
		monkey[n].jumpingSound[1]:setVolume(0.5)
		
		monkey[n].hat = love.math.random(0, monkey.hat.count)
	end
	
	monkey[1].moveLeft = 'a'
	monkey[1].moveRight = 'd'
	monkey[1].jump = 'w'
	monkey[1].throwL = 'lctrl'
	monkey[1].throwR = 'space'
	monkey[1].clr = {15, 0, 150, 200}
	monkey[1].moveJX = ui.W*0.1
	monkey[1].grenadeJX = ui.W*0.1
	monkey[1].moveJId = nil
	monkey[1].grenadeJId = nil
	
	monkey[2].moveLeft = 'kp4'
	monkey[2].moveRight = 'kp6'
	monkey[2].jump = 'kp8'
	monkey[2].throwL = 'right'
	monkey[2].throwR = 'kpenter'
	monkey[2].clr = {150, 0, 15, 200}
	monkey[2].moveJX = ui.W*0.9
	monkey[2].grenadeJX = ui.W*0.9
	monkey[2].moveJId = nil
	monkey[2].grenadeJId = nil
	
	monkey.moveJY = ui.H-ui.H/8
	monkey.grenadeJY = ui.H/2
	monkey.jRad = ui.H/8
end

function monkey.update(dt)
	for n = 1, monkey.numOf, 1 do
		if gamestate == 'playing' or gamestate == 'ended' then
			if monkey[n].moving then
				monkey[n].moveK = 1
			else
				monkey[n].moveK = 0
			end
			
			monkey[n].walking:update(dt)
			
			monkey[n].grenadeCD = monkey[n].grenadeCD - dt
			monkey[n].walkSoundTimer = monkey[n].walkSoundTimer + dt
			
			if monkey[n].walkSoundTimer % 0.2 and monkey[n].moving and monkey[n].onGround then
				monkey[n].walkingSound[1]:setPitch(math.random(0.8, 0.9))
				if not ui.muteSound then
					monkey[n].walkingSound[1]:play()
				end
			end
			
			--
			monkey[n].x = monkey[n].x + monkey[n].xVel * dt
			monkey[n].y = monkey[n].y - monkey[n].yVel * dt
			
			--  
			if monkey[n].onGround then
				monkey[n].xVel = monkey[n].xVel * (1 - math.min(dt*6.5*ui.K, 1))
				monkey[n].yVel = 0
			else
				monkey[n].xVel = monkey[n].xVel * (1 - math.min(dt*2*ui.K, 1))
				monkey[n].yVel = monkey[n].yVel - 600 * ui.K * dt
			end
			
			--[[if monkey[n].xVel > 6.5 then
				monkey[n].xVel = 6.5
			elseif monkey[n].xVel < -6.5 then
				monkey[n].xVel = -6.5
			end]]
			
			if monkey[n].alive then
				-- 
				if opSys == 'Windows' then
					if love.keyboard.isDown(monkey[n].moveLeft) and not love.keyboard.isDown(monkey[n].moveRight) and
					monkey[n].upToWall ~= 'r' then
						if monkey[n].onGround then
							monkey[n].xVel = monkey[n].xVel - monkey.speed
						else
							monkey[n].xVel = monkey[n].xVel - monkey.speed/5
						end
						monkey[n].direction = -1
						monkey[n].moving = true
					elseif love.keyboard.isDown(monkey[n].moveRight) and not love.keyboard.isDown(monkey[n].moveLeft) and 
					monkey[n].upToWall ~= 'l' then
						if monkey[n].onGround then
							monkey[n].xVel = monkey[n].xVel + monkey.speed
						else
							monkey[n].xVel = monkey[n].xVel + monkey.speed/5
						end
						monkey[n].direction = 1
						monkey[n].moving = true
					else
						monkey[n].moving = false
					end
				elseif opSys == 'Android' then
					--[[if monkey[n].onGround then
						monkey[n].xVel = monkey[n].xVel + monkey.speed * monkey[n].jX
					else
						monkey[n].xVel = monkey[n].xVel + monkey.speed * monkey[n].jX/5
					end]]
					
					if monkey[n].onGround then
						monkey[n].xVel = monkey[n].xVel + monkey.speed * monkey[n].direction * monkey[n].moveK
					else
						monkey[n].xVel = monkey[n].xVel + monkey.speed * monkey[n].direction * monkey[n].moveK / 5
					end
				end
				
				if monkey[n].hp <= 0 then
					monkey[n].alive = false
					if gamestate ~= 'ended' then
						monkey[n].lost = true
					end
				end
			end
		end
	end
	
	if monkey[1].lost or monkey[2].lost then
		monkey.endTimer = monkey.endTimer - dt
		if monkey.endTimer <= 0 then
			gamestate = 'ended'
		end
	end
	
	function monkey.keys(key)
		for n = 1, monkey.numOf, 1 do
			if monkey[n].alive then
				--
				if key == monkey[n].jump then
					if monkey[n].onGround then
						monkey[n].yVel = 450
						monkey[n].onGround = false
						if not ui.muteSound then
							monkey[n].jumpingSound[1]:play()
						end
					end
				end
				
				if gamestate == 'playing' then
					-- 
					if key == monkey[n].throwL then
						grenade.throw(-1, n)
					end
					if key == monkey[n].throwR then
						grenade.throw(1, n)
					end
				end
			end
		end
	end
	
	if opSys == 'Android' then
		for i, id in ipairs(touches) do
			local x, y = love.touch.getPosition(id)
			
			--  
			for n = 1, monkey.numOf, 1 do
				if math.abs(monkey[n].moveJX-x) < monkey.jRad and math.abs(monkey.moveJY-y) < monkey.jRad then
					if monkey[n].moveJId == nil and id ~= monkey[n].grenadeJId then
						monkey[n].moveJId = id
					end
				else
					monkey[n].moveJId = nil
				end
				if math.abs(monkey[n].grenadeJX-x) < monkey.jRad and math.abs(monkey.grenadeJY-y) < monkey.jRad then
					if monkey[n].grenadeJId == nil and id ~= monkey[n].moveJId then
						monkey[n].grenadeJId = id
					end
				else
					monkey[n].grenadeJId = nil
				end
				
				--
				if monkey[n].moveJId == id then
					--
					if math.abs(monkey[n].moveJX-x) > monkey.jRad/6 then
						if monkey[n].moveJX > x then
							monkey[n].direction = -1
						else
							monkey[n].direction = 1
						end
						
						monkey[n].moving = true
					else
						monkey[n].moving = false
					end
					
					--
					if monkey.moveJY-y > monkey.jRad/2 then
						if monkey[n].onGround then
							monkey[n].yVel = 450*ui.K
							monkey[n].onGround = false
							if not ui.muteSound then
								monkey[n].jumpingSound[1]:play()
							end
						end
					end
				end
				
				--
				if monkey[n].grenadeJId == id then
					if monkey[n].grenadeJX-x < -monkey.jRad/2 then
						grenade.throw(1, n)
					end
					if monkey[n].grenadeJX-x > monkey.jRad/2 then
						grenade.throw(-1, n)
					end
				end
			end
		end
	end
	
	function monkey.releaseMove(id, x, y, dx, dy)
		for n = 1, monkey.numOf, 1 do
			if monkey[n].moveJId ~= nil and id == monkey[n].moveJId then
				monkey[n].moveJId = nil
				monkey[n].moving = false
			end
		end
	end
end

function monkey.draw()
	love.graphics.setColor(255, 255, 255)
	for n = 1, monkey.numOf, 1 do
		if monkey[n].alive then
			if monkey[n].moving and monkey[n].onGround then
				monkey[n].walking:draw(math.floor(monkey[n].x), math.floor(monkey[n].y), 0, monkey[n].direction*ui.K, ui.K, monkey.width/2/ui.K, monkey.height/ui.K)
			else
				love.graphics.draw(monkey.idle, math.floor(monkey[n].x), math.floor(monkey[n].y), 0, monkey[n].direction*ui.K, ui.K, monkey.width/2/ui.K, monkey.height/ui.K)
			end
			if monkey[n].hat ~= 0 then
				love.graphics.draw(monkey.hat[monkey[n].hat].img, math.floor(monkey[n].x+monkey.hat[monkey[n].hat].xO), math.floor(monkey[n].y+monkey.hat[monkey[n].hat].yO), 0, monkey[n].direction*ui.K, ui.K, monkey.width/2/ui.K, monkey.height/ui.K)
			end
		end
	end
end