world = {}

function world.load()
	world.grLvl = 700*ui.K
	
	world.background = love.graphics.newImage('textures/world/background1.png')
	world.backgroundFront = love.graphics.newImage('textures/world/background1_front.png')
	world.backgroundFightText = love.graphics.newImage('textures/world/background1_fighttext.png')
	world.backgroundNum = {}
	world.backgroundNum[3] = love.graphics.newImage('textures/world/background1_num3.png')
	world.backgroundNum[2] = love.graphics.newImage('textures/world/background1_num2.png')
	world.backgroundNum[1] = love.graphics.newImage('textures/world/background1_num1.png')
	world.backgroundP1WonText = love.graphics.newImage('textures/world/background1_p1wontext.png')
	world.backgroundP2WonText = love.graphics.newImage('textures/world/background1_p2wontext.png')
	world.backgroundDrawText = love.graphics.newImage('textures/world/background1_drawtext.png')
	
	world.wall = {}
	
	--Загрузка тайлов для платформ
	world.wallTile = {}
	world.wallTile[1] = love.graphics.newImage('textures/world/walltile1.png')
	world.wallTile[2] = love.graphics.newImage('textures/world/walltile2.png')
	world.wallTile[3] = love.graphics.newImage('textures/world/walltile3.png')
	
	world.currentLevel = nil
	
	level.load0()
end

function world.update(dt)
	for n = 1, monkey.numOf, 1 do		
		--Определиние того, не сошла ли обезьяна с платформы
		if monkey[n].onWall ~= nil then
			if monkey[n].x > world.wall[monkey[n].onWall].x - monkey.width/2 or monkey[n].x < world.wall[monkey[n].onWall].x + world.wall[monkey[n].onWall].w + monkey.width/2 then
				monkey[n].onGround = false
				monkey[n].onWall = nil
			end 
		end
		
		--Столкновения с платформами
		for f = 1, world.numOfWalls, 1 do
			if monkey[n].x > world.wall[f].x - monkey.width/2 and monkey[n].x < world.wall[f].x + world.wall[f].w + monkey.width/2 and
			monkey[n].y > world.wall[f].y and monkey[n].y < world.wall[f].y + world.wall[f].h + monkey.height then
				if math.abs(monkey[n].x - (world.wall[f].x - monkey.width/2)) < math.abs(monkey[n].x - (world.wall[f].x + world.wall[f].w + monkey.width/2)) and
				math.abs(monkey[n].x - (world.wall[f].x - monkey.width/2)) < math.abs(monkey[n].y - world.wall[f].y) and
				math.abs(monkey[n].x - (world.wall[f].x - monkey.width/2)) < math.abs(monkey[n].y - world.wall[f].y - world.wall[f].h - monkey.height) then
					monkey[n].x = world.wall[f].x - monkey.width/2
					monkey[n].xVel = 0
				end
				if math.abs(monkey[n].x - (world.wall[f].x - monkey.width/2)) > math.abs(monkey[n].x - (world.wall[f].x + world.wall[f].w + monkey.width/2)) and
				math.abs(monkey[n].x - (world.wall[f].x + world.wall[f].w + monkey.width/2)) < math.abs(monkey[n].y - world.wall[f].y) and
				math.abs(monkey[n].x - (world.wall[f].x + world.wall[f].w + monkey.width/2)) < math.abs(monkey[n].y - world.wall[f].y - world.wall[f].h - monkey.height) then
					monkey[n].x = world.wall[f].x + world.wall[f].w + monkey.width/2
					monkey[n].xVel = 0
				end
				if math.abs(monkey[n].y - world.wall[f].y) < math.abs(monkey[n].y - world.wall[f].y - world.wall[f].h - monkey.height) and
				math.abs(monkey[n].y - world.wall[f].y) < math.abs(monkey[n].x - (world.wall[f].x - monkey.width/2)) and
				math.abs(monkey[n].y - world.wall[f].y) < math.abs(monkey[n].x - (world.wall[f].x + world.wall[f].w + monkey.width/2)) then
					monkey[n].y = world.wall[f].y
					monkey[n].yVel = 0
				end
				if math.abs(monkey[n].y - world.wall[f].y) > math.abs(monkey[n].y - world.wall[f].y - world.wall[f].h - monkey.height) and
				math.abs(monkey[n].y - world.wall[f].y - world.wall[f].h - monkey.height) < math.abs(monkey[n].x - (world.wall[f].x - monkey.width/2)) and
				math.abs(monkey[n].y - world.wall[f].y - world.wall[f].h - monkey.height) < math.abs(monkey[n].x - (world.wall[f].x + world.wall[f].w + monkey.width/2)) then
					monkey[n].y = world.wall[f].y + world.wall[f].h + monkey.height
					monkey[n].yVel = 0
				end
			end
			
			--Определение того, что обезьяна на платформе
			if monkey[n].x >= world.wall[f].x - monkey.width/2 and monkey[n].x <= world.wall[f].x + world.wall[f].w + monkey.width/2 and
			monkey[n].y == world.wall[f].y then
				monkey[n].onGround = true
				monkey[n].onWall = f
			end
		end
		
		if monkey[n].y > love.graphics.getHeight() + monkey.height then
			monkey[n].hp = 0
		end
		
		if monkey[n].x < 0 then
			monkey[n].x = 0
			monkey[n].xVel = 0
		elseif monkey[n].x > love.graphics.getWidth() then
			monkey[n].x = love.graphics.getWidth()
			monkey[n].xVel = 0
		end
		
		if monkey[n].y < monkey.height then
			monkey[n].y = monkey.height
			monkey[n].yVel = 0
		end
	end
	
	for g = 1, grenade.numOf, 1 do
		if not grenade[g].blewUp then
			if grenade[g].y < 0 then
				grenade[g].y = 0
				grenade[g].yVel = -grenade[g].yVel * grenade.bounce
				grenade.collisionSound[1]:stop()
				if not ui.muteSound then
					grenade.collisionSound[1]:play()
				end
			end
			
			if grenade[g].x < 0 then
				grenade[g].x = 0
				grenade[g].xVel = -grenade[g].xVel * grenade.bounce
				grenade.collisionSound[1]:stop()
				if not ui.muteSound then
					grenade.collisionSound[1]:play()
				end
			elseif grenade[g].x > love.graphics.getWidth() then
				grenade[g].x = love.graphics.getWidth()
				grenade[g].xVel = -grenade[g].xVel * grenade.bounce
				grenade.collisionSound[1]:stop()
				if not ui.muteSound then
					grenade.collisionSound[1]:play()
				end
			end
			
			for f = 1, world.numOfWalls, 1 do
				if grenade[g].x >= world.wall[f].x and grenade[g].x <= world.wall[f].x + world.wall[f].w and
				grenade[g].y > world.wall[f].y and grenade[g].y < world.wall[f].y + world.wall[f].h then
					if not grenade[g].inWall[f] then
						if math.abs(grenade[g].x - world.wall[f].x) < math.abs(grenade[g].x - (world.wall[f].x + world.wall[f].w)) and
						math.abs(grenade[g].x - world.wall[f].x) < math.abs(grenade[g].y - world.wall[f].y) and
						math.abs(grenade[g].x - world.wall[f].x) < math.abs(grenade[g].y - world.wall[f].y - world.wall[f].h) then
							--grenade[g].x = world.wall[f].x
							grenade[g].xVel = -grenade[g].xVel * grenade.bounce
							grenade.collisionSound[1]:stop()
							if not ui.muteSound then
								grenade.collisionSound[1]:play()
							end
						elseif math.abs(grenade[g].x - world.wall[f].x) > math.abs(grenade[g].x - (world.wall[f].x + world.wall[f].w)) and
						math.abs(grenade[g].x - (world.wall[f].x + world.wall[f].w)) < math.abs(grenade[g].y - world.wall[f].y) and
						math.abs(grenade[g].x - (world.wall[f].x + world.wall[f].w)) < math.abs(grenade[g].y - world.wall[f].y - world.wall[f].h) then
							--grenade[g].x = world.wall[f].x + world.wall[f].w
							grenade[g].xVel = -grenade[g].xVel * grenade.bounce
							grenade.collisionSound[1]:stop()
							if not ui.muteSound then
								grenade.collisionSound[1]:play()
							end
						elseif math.abs(grenade[g].y - world.wall[f].y) < math.abs(grenade[g].y - world.wall[f].y - world.wall[f].h) and
						math.abs(grenade[g].y - world.wall[f].y) < math.abs(grenade[g].x - world.wall[f].x) and
						math.abs(grenade[g].y - world.wall[f].y) < math.abs(grenade[g].x - (world.wall[f].x + world.wall[f].w)) then
							--grenade[g].y = world.wall[f].y
							grenade[g].yVel = -grenade[g].yVel * grenade.bounce
							grenade.collisionSound[1]:stop()
							if not ui.muteSound then
								grenade.collisionSound[1]:play()
							end
						elseif math.abs(grenade[g].y - world.wall[f].y) > math.abs(grenade[g].y - world.wall[f].y - world.wall[f].h) and
						math.abs(grenade[g].y - world.wall[f].y - world.wall[f].h) < math.abs(grenade[g].x - world.wall[f].x) and
						math.abs(grenade[g].y - world.wall[f].y - world.wall[f].h) < math.abs(grenade[g].x - (world.wall[f].x + world.wall[f].w)) then
							--grenade[g].y = world.wall[f].y + world.wall[f].h
							grenade[g].yVel = -grenade[g].yVel * grenade.bounce
							grenade.collisionSound[1]:stop()
							if not ui.muteSound then
								grenade.collisionSound[1]:play()
							end
						end
					end
					grenade[g].inWall[f] = true
				else
					grenade[g].inWall[f] = false
				end
			end
		end
	end
end

function world.draw()
	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(world.background, 0, 0, 0, ui.K, ui.K)
	if gamestate == 'wait' or gamestate == 'menu' or gamestate == 'startScreen' then
		love.graphics.draw(world.backgroundNum[math.ceil(ui.startTimer)], 0, 0, 0, ui.K, ui.K)
	elseif monkey[1].alive and monkey[2].alive then
		love.graphics.draw(world.backgroundFightText, 0, 0, 0, ui.K, ui.K)
	elseif gamestate == 'ended' then
		if monkey[1].lost and monkey[2].lost then
			love.graphics.draw(world.backgroundDrawText, 0, 0, 0, ui.K, ui.K)
		elseif monkey[1].lost then
			love.graphics.draw(world.backgroundP2WonText, 0, 0, 0, ui.K, ui.K)
		elseif monkey[2].lost then
			love.graphics.draw(world.backgroundP1WonText, 0, 0, 0, ui.K, ui.K)
		end
	end
	love.graphics.setColor(255, 255, 0)
	love.graphics.setFont(ui.pixelFont)
	if ui.gameTimer <= 999 then
		love.graphics.printf(':'..math.floor(ui.gameTimer), 268*ui.K, 1*ui.K, 100*ui.K, 'right')
	end
	love.graphics.setFont(ui.defaultFont)
	love.graphics.setColor(255, 255, 255)
	love.graphics.draw(world.backgroundFront, 0, 0, 0, ui.K, ui.K)
	
	for g = 1, grenade.numOf, 1 do
		if grenade[g].blewUp then
			love.graphics.setColor(255, 255, 255)
			love.graphics.draw(grenade.explosionMark, grenade[g].x, grenade[g].y, grenade[g].rot, ui.K, ui.K, 106*ui.K, 106*ui.K)
		end
	end
	
	for f = 1, world.numOfWalls, 1 do
		if opSys == 'Windows' then
			for tr = 1, world.wall[f].w/12, 1 do
				for t = 1, world.wall[f].h/12, 1 do
					love.graphics.draw(world.wallTile[world.wall[f].tile[t*tr]], (world.wall[f].x + 12*(tr-1))*ui.K, (world.wall[f].y + 12*(t-1))*ui.K, 0, ui.K, ui.K)
				end
			end
		elseif opSys == 'Android' then
			love.graphics.setColor(100, 100, 100)
			love.graphics.rectangle('fill', world.wall[f].x, world.wall[f].y, world.wall[f].w, world.wall[f].h)
		end
		
		if ui.showInfo then
			love.graphics.setColor(0, 255, 0)
			love.graphics.rectangle('line', world.wall[f].x, world.wall[f].y, world.wall[f].w, world.wall[f].h)
			love.graphics.setColor(0, 255, 0, 100)
			love.graphics.rectangle('line', world.wall[f].x - monkey.width/2, world.wall[f].y , world.wall[f].w + monkey.width, world.wall[f].h + monkey.height)
			love.graphics.setColor(255, 255, 255, 255)
		end
	end
end